import waba.ui.*;
import waba.fx.*;


/**
 * TAKEBOZU
 */

public class Bozu extends MainWindow
{
    static final int PLAY=0;
    static final int ABOUT=1;
    static final byte IMAGEMAX = 24;
    Image[] BozuImage = new Image[IMAGEMAX];
    int ImageNum, OldImageNum;
    boolean FirstTime = true;
    Timer Timer;
    static final int Scale = 100;
    static final int Grav = 40;
    static final int Limit = 30;
    int ImageX, ImageY;
    int OldImageX, OldImageY;
    int VX, VY;
    int GoalX, GoalY;
    int state=PLAY;

    public Bozu() {
	GoalX = ImageX = OldImageX = this.width * Scale / 2;
	GoalY = ImageY = OldImageY= this.height * Scale / 2;
	VX = VY = 0;
	ImageNum = 0;
	OldImageNum = 23;

	if (Timer == null) {
	    Timer = addTimer(50);
	}
    }

    public void onEvent(Event event) {
	if (event.type == PenEvent.PEN_DOWN) {
	    if(state==ABOUT){
		drawAbout(new Graphics(this),false);
	    }
	    else{
		PenEvent pe = (PenEvent)event;
		GoalX = pe.x * Scale;
		GoalY = pe.y * Scale;
	    }
	}
	else if (event.type == ControlEvent.TIMER && state!=ABOUT) {
	    moveBozu();
	    this.repaint();
	}
	else if(event instanceof KeyEvent){
	    KeyEvent e=(KeyEvent)event;
	    if (e.key==IKeys.MENU || e.key=='i'){
		drawAbout(new Graphics(this),state!=ABOUT);
	    }
	}
    }

    private void moveBozu() {
	int dx, dy;
	int ax, ay;
	int absx,absy;

	dx = GoalX - ImageX;
	dy = GoalY - ImageY;

	if(dx < 0){
	    absx = -dx;
	}
	else{
	    absx = dx;
	}
	if(dy < 0){
	    absy = -dy;
	}
	else{
	    absy = dy;
	}
	int abs = absx + absy;
	if(abs != 0){
	    ax = Grav * dx / abs;
	    ay = Grav * dy / abs;
	}
	else {
	    ax = ay = 0;
	}

	VX += ax;
	VY += ay;

	VX = (VX * 95) / 100;
	VY = (VY * 95) / 100;
	if(VX > -Limit && VX < Limit
	   && dx > -Limit && dx < Limit) {
	    VX = 0;
	    GoalX = ImageX;
	}
	if(VY > -Limit && VY < Limit
	   && dy > -Limit && dy < Limit) {
	    VY = 0;
	    GoalY = ImageY;
	}

	ImageX += VX;
	ImageY += VY;
	
	ImageNum++;
	if (ImageNum >= IMAGEMAX) {
	    ImageNum = 0;
	}
    }

    public void onPaint(Graphics g) {
	if (FirstTime) {
	    loadImage();
	    FirstTime = false;
	}
	int w, h;
	w = BozuImage[OldImageNum].getWidth();
	h = BozuImage[OldImageNum].getHeight();
	g.setDrawOp(g.DRAW_OVER);
	g.drawImage(BozuImage[OldImageNum]
		    , (OldImageX / Scale) - w /2
		    , (OldImageY / Scale) - h /2);
	w = BozuImage[ImageNum].getWidth();
	h = BozuImage[ImageNum].getHeight();
	g.drawImage(BozuImage[ImageNum]
		    , (ImageX / Scale) - w /2
		    , (ImageY / Scale) - h /2);
	OldImageNum = ImageNum;
	OldImageX = ImageX;
	OldImageY = ImageY;
    }


    public void drawRect(Graphics g,int x,int y,int w,int h){
	g.setColor(255,255,255);
	g.fillRect(x,y,w,h);
	g.setColor(0,0,0);
	w--;
	h--;
	g.drawLine(x,y,x+w,y);
	g.drawLine(x+w,y,x+w,y+h);
	g.drawLine(x,y,x,y+h);
	g.drawLine(x,y+h,x+w,y+h);
    }

    public void drawCenteredText(Graphics g,String s,int x,int y){
	Font font = new Font("Helvetica", Font.PLAIN, 12);
	FontMetrics fm=getFontMetrics(font);
	g.setFont(font);
	g.drawText(s,x-fm.getTextWidth(s)/2,y-fm.getAscent()/2);
    }

    public void drawAbout(Graphics g,boolean b){
	int w=this.width;
	int h=this.height / 2;
	if(b){
	    Sound.beep();
	    Sound.tone(2000,200);
	    Sound.tone(4000,200);
	    g.translate(0,this.height/4);
	    state=ABOUT;
	    drawRect(g,0,0,w,h);
	    drawCenteredText(g,"TAKEBOZU",w/2,h/5);
	    drawCenteredText(g,"by TAKEchi Masashi",w/2,2*h/5);
	    drawCenteredText(g,"take@TAKEchon.NET",w/2,3*h/5);
	    drawCenteredText(g,"http://www.TAKEchon.NET/",w/2,4*h/5);
	    g.translate(0,-this.height/4);
	}
	else{
	    state=PLAY;
	    damageRect(0,this.height/4,w,h);
	}                                           
    }
    private void loadImage() {
	BozuImage[0] = new Image("bozu01.bmp");
	BozuImage[1] = new Image("bozu02.bmp");
	BozuImage[2] = new Image("bozu03.bmp");
	BozuImage[3] = new Image("bozu04.bmp");
	BozuImage[4] = new Image("bozu05.bmp");
	BozuImage[5] = new Image("bozu06.bmp");
	BozuImage[6] = new Image("bozu07.bmp");
	BozuImage[7] = new Image("bozu08.bmp");
	BozuImage[8] = new Image("bozu09.bmp");
	BozuImage[9] = new Image("bozu10.bmp");
	BozuImage[10] = new Image("bozu11.bmp");
	BozuImage[11] = new Image("bozu12.bmp");
	BozuImage[12] = new Image("bozu13.bmp");
	BozuImage[13] = new Image("bozu14.bmp");
	BozuImage[14] = new Image("bozu15.bmp");
	BozuImage[15] = new Image("bozu16.bmp");
	BozuImage[16] = new Image("bozu17.bmp");
	BozuImage[17] = new Image("bozu18.bmp");
	BozuImage[18] = new Image("bozu19.bmp");
	BozuImage[19] = new Image("bozu20.bmp");
	BozuImage[20] = new Image("bozu21.bmp");
	BozuImage[21] = new Image("bozu22.bmp");
	BozuImage[22] = new Image("bozu23.bmp");
	BozuImage[23] = new Image("bozu24.bmp");
    }
}
